library dbhook;

{ Wichtiger Hinweis zur DLL-Speicherverwaltung: Sharemem mu die erste
 Unit in der uses-Klausel Ihrer Bibliothek und Ihres Projekts sein,
 wenn Ihre DLL Prozeduren und Funktionen exportiert, die
 Strings als Parameter oder Funktionsergebnisse bergeben. Dies
 betrifft alle Strings, die an Ihre DLL oder von Ihrer DLL bergeben werden--selbst diejenigen,
 die sich in Records oder Klassen befinden. Sharemem ist die Schnittstelle zu
 BORLNDMM.DLL, die den gemeinsamen Zugriff auf den Speicher verwaltet; DELPHIMM.DLL
 mu mit Ihrer DLL weitergegeben werden. Wenn Sie BORLNDMM.DLL nicht verwenden mchten, mssen
 Strings als PChar oder ShortString bergeben werden.}

uses
  Windows,
  Messages,
  sysutils;

const ScrollStep=50;

var
  HookHandle: Cardinal = 0;
  WindowHandle: Cardinal = 0;
  mouse: TMouseHookStruct;
  mousedown: Boolean;
  mousex,mousey:integer;

  VellumWnd: THandle;
  ScrollWnd: array[0..1] of THandle;
  ScrollCnt:Integer;

function GetWindows(Handle: HWND; Info: Pointer): BOOL; stdcall;
var
  Name: array[0..255] of Char;
  i:integer;
begin
  Result := True;
  i:=GetClassName(Handle, Name, 255);

  if stricomp(Name,'VellumAFA')=0 then
  begin
    VellumWnd := Handle;
    Result := false;//ende
  end;
end;

function GetChildWindows(Handle: HWND; Info: Pointer): BOOL; stdcall;
var
  Name: array[0..255] of Char;
  i:integer;
begin
  Result := True;
  i:=GetClassName(Handle, Name, 255);

  if stricomp(Name,'ScrollBar')=0 then
  begin
    ScrollWnd[ScrollCnt] := Handle;
    ScrollCnt := ScrollCnt +1;
    if ScrollCnt > 1 then
     Result := false;//ende
  end;
end;

function SearchVellumWindows: boolean;
begin
  {Modul suchen}
  VellumWnd:=0;
  EnumWindows(@GetWindows, 11);
  if VellumWnd<>0 then
  begin
    ScrollCnt:=0;
    EnumChildWindows(VellumWnd, @GetChildWindows, 11);
  end;
  Result := VellumWnd<>0;
end;

function MAKELANGID(p, s:longint):longint;
begin
   result:=((((s)) shl 10) or (p));
end;

procedure Scroll(idx:integer;left:boolean);
var pos,e:LongInt;
    r: TRect;
    thread: Thandle;
    c: array[0..255] of char;
begin
  if SearchVellumWindows then //wichtig! bei andrem Hauptfenster sind die VAriablen anders initialisiert!
  begin
    if GetForegroundWindow = VellumWnd then
    begin
      GetWindowRect(ScrollWnd[idx], r);
      pos:=0;
      if left then
        pos := makelong( 1,1 )//x,y
      else
        pos := makelong( r.right-r.left-1,r.bottom-r.top-1 );//x,y
      PostMessage(ScrollWnd[idx],WM_LBUTTONDOWN,MK_LBUTTON,pos);
      PostMessage(ScrollWnd[idx],WM_LBUTTONUP,MK_LBUTTON,pos);
    end;
  end;
end;


function KeyboardHookProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
begin
//es ist ebenfalls moeglich die Bearbeitung an eine Bedingung zu knuepfen
//it's possible to call CallNextHookEx conditional only.
  Result := CallNextHookEx(HookHandle, nCode, wParam, lParam);
  case nCode < 0 of
    TRUE:    exit; //wenn code kleiner 0 wird nix gemacht
                //if code smaller 0 nothing has to be done
    FALSE:
      begin
//Hier kann jetzt alles bearbeitet werden
//Here one can work with the parameters
       CopyMemory(@mouse, PMOUSEHOOKSTRUCT(lParam), sizeof(TMOUSEHOOKSTRUCT));
       case wParam of
         WM_MOUSEMOVE:
           begin
             if mousedown then
             begin
               if (abs(mousex-mouse.pt.x)>ScrollStep) then
               begin
//                 MessageBeep($ffff);
                 Scroll(0,(mousex-mouse.pt.x)<0);
                 mousex := mouse.pt.x;
               end;
               if (abs(mousey-mouse.pt.y)>ScrollStep) then
               begin
//                 MessageBeep($ffff);
                 Scroll(1,(mousey-mouse.pt.y)<0);
                 mousey := mouse.pt.y;
               end;
             end;
           end;
         WM_MBUTTONDOWN:
           begin
//             MessageBeep($ffff);
             mousedown:=true;
             mousex := mouse.pt.x;
             mousey := mouse.pt.y;
           end;
         WM_MBUTTONUP:
           begin
             mousedown:=false;
             mousex := mouse.pt.x;
             mousey := mouse.pt.y;
           end;
       end;
      end;
  end;
end;

function UninstallHook: Boolean; stdcall;
begin
//Hook aus der Hookchain entfernen
//Uninstall hook from hook chain
  Result := UnhookWindowsHookEx(HookHandle);
  HookHandle := 0;
end;

function InstallHook(Hwnd: Cardinal): Boolean; stdcall;
begin
  mousedown := False;
  Result := False;
  if HookHandle = 0 then begin
//Erstmal Hook installieren
//First install the hook
    HookHandle := SetWindowsHookEx(WH_MOUSE, @KeyboardHookProc, HInstance, 0);
//Uebergebenes Fensterhandle sichern
//Save the given window handle
    WindowHandle := Hwnd;
    Result := True;
  end;
end;

procedure Run(hwnd:THandle; hinst:THandle; CmdLine:PChar; nCmdShow:integer); stdcall;
var r:boolean;
    msg:TMsg;
begin
//  LoadDll;
  InstallHook(0);
  while SearchVellumWindows do
  begin
    if PeekMessage(Msg, 0, 0, 0, PM_REMOVE) then
    begin
      TranslateMessage(Msg);
      DispatchMessage(Msg);
    end;
    Sleep(100);
  end;
  UninstallHook;
//  UnLoadDLL;
end;

exports
//Installations- und Deinstallationsroutine exportieren
//Export the installation and deinstallation routine
  InstallHook,
  UninstallHook,
  Run;
end.

